#!/bin/bash

#    devparanoia - Use dd only if a device fullfill certain requirements.
#    Copyright (C) Copyright (C) 2016 David B. Hedlund <public@beloved.name>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# The name devparanoia comes from cdparanoia that is developed by Xiph.Org Foundation, the same team behind Vorbis and Opus."
dev=sdb;
require_device_connector=usb;
image="/home/cryptonite/1-CPU/Software/Dists/trisquel_7.0_amd64.iso";
execute="sudo dd if=\"$image\" of=/dev/$dev bs=4M conv=noerror,sync";

clear

# Evaluate variables
if [[ "$(echo -n $dev | tail -c 1)" != [0-9]* ]]; then echo "OK; \$dev=$dev is a drive."; else write=false; echo "WARNING: Set \$dev=$dev (partition device) to \$dev=${dev//[[:digit:]]/} (drive device) as partition devices cannot be booted."; exit; fi;
if [ "$require_device_connector" == "usb" ] || [ "$require_device_connector" == "ata" ]; then echo "OK: \$require_device_connector=$require_device_connector"; else write=false; echo "WARNING: Set \$require_device_connector=$require_device_connector to ata|usb."; exit; fi

# Device file check
if [ -b /dev/$dev ]; then echo "OK: /dev/$dev block device exist."; else write=false; echo "WARNING: /dev/$dev block device does not exist."; exit; fi

# Root partition device check
if [ "$(findmnt | grep /dev/$dev | colrm 2)" == / ]; then write=false; echo "WARNING: $dev contains the root partition of this system. Saving your system distribution from being destroyed!"; exit

else

    echo "OK: $dev is not a system device.";

    # Device connector check
    if [ "$(find /dev/disk/by-id/ -ls | grep /$dev | grep "/dev/disk/by-id/usb")" ]; then device_connector=usb;
    elif [ "$(find /dev/disk/by-id/ -ls | grep /$dev | grep "/dev/disk/by-id/ata")" ]; then device_connector=ata;
    fi

    if [ "$require_device_connector" == "$device_connector" ]; then echo "OK: $dev is a $device_connector device connector as required."; else echo "WARNING: $dev device connector: $device_connector Required device connector: $require_device_connector device"; fi

    # Mount check - requires sudo so added last
    if [ "$(mount | grep $dev)" ]; then echo "Requesting umount permission" && sudo umount /dev/$dev?; fi
    if [ "$(mount | grep $dev)" ]; then write=false; echo "WARNING: Unmount error for $dev. Never use dd not write to a mounted device."; exit; else echo "OK: $dev is not mounted."; fi

    if [ "$write" = false ]; then echo "EXIT: Something went wrong" && exit;
    else echo "
BE EXTREMELY CAREFUL if you use the dd command, since a small typo can make all of the data on your disk useless.

$execute";

	while true; do
	    read -p "Do you wish to execute above command? (y/n)" yn
	    case $yn in
		[Yy]* ) eval "$execute"; break;;
		[Nn]* ) exit;;
		* ) echo "Please answer yes or no.";;
	    esac
	done

    fi

fi
